---
title: Presentation API
slug: Web/API/Presentation_API
tags:
  - API
  - Experimental
  - NeedsContent
  - Presentation API
  - Reference
---
<p>{{securecontext_header}}{{SeeCompatTable}}{{APIRef("Presentation API")}}</p>

<p><span class="seoSummary">The Presentation API lets a {{Glossary("user agent")}} (such as a Web browser) effectively display web content through large presentation devices such as projectors and network-connected televisions.</span> Supported types of multimedia devices include both displays which are wired using HDMI, DVI, or the like, or wireless, using <a href="https://www.dlna.org/">DLNA</a>, <a href="/en-US/docs/">Chromecast</a>, <a href="https://developer.apple.com/airplay/">AirPlay</a>, or <a href="https://www.wi-fi.org/discover-wi-fi/miracast">Miracast</a>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/14544/presentation%20mode%20illustration.png" style="height: 382px; width: 945px;"></p>

<p>In general, a web page uses the Presentation Controller API to specify the web content to be rendered on presentation device and initiate the presentation session. With Presentation Receiver API, the presenting web content obtains the session status. With providing both the controller page and the receiver one with a messaged-based channel, a Web developer can implement the interaction between these two pages.</p>

<p>Depending on the connection mechanism provided by the presentation device, any controller- and receiver page can be rendered by the same user agent, or by separated user agents.</p>

<ul>
 <li>For 1-UA mode devices, both pages are loaded by the same user agent. However, rendering result of the receiver page will be sent to the presentation device via supported remote rendering protocol.</li>
 <li>For 2-UAs mode device, the receiver page is loaded directly on the presentation device. Controlling user agent communicates with presentation device via supported presentation control protocol, to control the presentation session and to transmit the message between two pages.</li>
</ul>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("Presentation")}}</dt>
 <dd>In controlling browsing context, the <code>Presentation</code> interface provides a mechanism to override the browser default behavior of launching presentation to external screen. In receiving browsing context, <code>Presentation</code> interface provides the access to the available presentation connections.</dd>
 <dt>{{domxref("PresentationRequest")}}</dt>
 <dd>Initiates or reconnects to a presentation made by a controlling browsing context.</dd>
 <dt>{{domxref("PresentationAvailability")}}</dt>
 <dd>A <a href="/en-US/docs/Web/API/PresentationAvailability">PresentationAvailability</a> object is associated with available presentation displays and represents the <dfn>presentation display availability</dfn> for a presentation request.</dd>
 <dt>{{domxref("PresentationConnectionAvailableEvent")}}</dt>
 <dd>The <code>PresentationConnectionAvailableEvent</code> is fired on a <a href="/en-US/docs/Web/API/PresentationRequest" title="The PresentationRequest interface of the Presentation API provides methods for starting a new presentation or joining an active one."><code>PresentationRequest</code></a> when a connection associated with the object is created.</dd>
 <dt>{{domxref("PresentationConnection")}}</dt>
 <dd>Each presentation connection is represented by a <a href="/en-US/docs/Web/API/PresentationConnection">PresentationConnection</a> object.</dd>
 <dt>{{domxref("PresentationConnectionCloseEvent")}}</dt>
 <dd>A <code>PresentationConnectionCloseEvent</code> is fired when a presentation connection enters a <code>closed</code> state.</dd>
 <dt>{{domxref("PresentationReceiver")}}</dt>
 <dd>The <a href="/en-US/docs/Web/API/PresentationReceiver">PresentationReceiver</a> allows a receiving browsing context to access the controlling browsing contexts and communicate with them.</dd>
 <dt>{{domxref("PresentationConnectionList")}}</dt>
 <dd><code>PresentationConnectionList</code> represents the collection of non-terminated presentation connections. It is also a monitor for the event of new available presentation connection.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>Example codes below highlight the usage of main features of the Presentation API: <code>controller.html</code> implements the controller and <code>presentation.html</code> implements the presentation. Both pages are served from the domain <code>http://example.org</code> (<code>http://example.org/controller.html</code> and <code>http://example.org/presentation.html</code>). These examples assume that the controlling page is managing one presentation at a time. Please refer to the comments in the code examples for further details.</p>

<section id="monitor-availability-of-presentation-displays-example">
<h3 id="Monitor_availability_of_presentation_displays"><span>Monitor availability of presentation displays </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- controller.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">id</span>=<span class="hljs-string">"presentBtn"</span> <span class="hljs-attr">style</span>=<span class="hljs-string">"display: none;"</span>&gt;</span>Present<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  <span class="hljs-comment">// The Present button is visible if at least one presentation display is available</span>
  <span class="hljs-keyword">var</span> presentBtn = <span class="hljs-built_in">document</span>.getElementById(<span class="hljs-string">"presentBtn"</span>);
  <span class="hljs-comment">// It is also possible to use relative presentation URL e.g. "presentation.html"</span>
  <span class="hljs-keyword">var</span> presUrls = [<span class="hljs-string">"http://example.com/presentation.html"</span>,
                  <span class="hljs-string">"http://example.net/alternate.html"</span>];
  <span class="hljs-comment">// show or hide present button depending on display availability</span>
  <span class="hljs-keyword">var</span> handleAvailabilityChange = <span class="hljs-function"><span class="hljs-keyword">function</span>(<span class="hljs-params">available</span>) </span>{
    presentBtn.style.display = available ? <span class="hljs-string">"inline"</span> : <span class="hljs-string">"none"</span>;
  };
  <span class="hljs-comment">// Promise is resolved as soon as the presentation display availability is</span>
  <span class="hljs-comment">// known.</span>
  <span class="hljs-keyword">var</span> request = <span class="hljs-keyword">new</span> PresentationRequest(presUrls);
  request.getAvailability().then(<span class="hljs-function"><span class="hljs-keyword">function</span>(<span class="hljs-params">availability</span>) </span>{
    <span class="hljs-comment">// availability.value may be kept up-to-date by the controlling UA as long</span>
    <span class="hljs-comment">// as the availability object is alive. It is advised for the web developers</span>
    <span class="hljs-comment">// to discard the object as soon as it's not needed.</span>
    handleAvailabilityChange(availability.value);
    availability.onchange = <span class="hljs-function"><span class="hljs-keyword">function</span>() </span>{ handleAvailabilityChange(<span class="hljs-keyword">this</span>.value); };
  }).catch(<span class="hljs-function"><span class="hljs-keyword">function</span>() </span>{
    <span class="hljs-comment">// Availability monitoring is not supported by the platform, so discovery of</span>
    <span class="hljs-comment">// presentation displays will happen only after request.start() is called.</span>
    <span class="hljs-comment">// Pretend the devices are available for simplicity; or, one could implement</span>
    <span class="hljs-comment">// a third state for the button.</span>
    handleAvailabilityChange(<span class="hljs-literal">true</span>);
  });
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<section id="starting-a-new-presentation-example">
<h3 id="Starting_a_new_presentation"><span>Starting a new presentation </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- controller.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  presentBtn.onclick = <span class="hljs-function"><span class="hljs-keyword">function</span> () </span>{
    <span class="hljs-comment">// Start new presentation.</span>
    request.start()
      <span class="hljs-comment">// The connection to the presentation will be passed to setConnection on</span>
      <span class="hljs-comment">// success.</span>
      .then(setConnection);
      <span class="hljs-comment">// Otherwise, the user canceled the selection dialog or no screens were</span>
      <span class="hljs-comment">// found.</span>
  };
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<section id="reconnect-to-a-presentation-example">
<h3 id="Reconnect_to_a_presentation"><span>Reconnect to a presentation </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- controller.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">id</span>=<span class="hljs-string">"reconnectBtn"</span> <span class="hljs-attr">style</span>=<span class="hljs-string">"display: none;"</span>&gt;</span>Reconnect<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  <span class="hljs-keyword">var</span> reconnect = <span class="hljs-function"><span class="hljs-keyword">function</span> () </span>{
    <span class="hljs-comment">// read presId from localStorage if exists</span>
    <span class="hljs-keyword">var</span> presId = localStorage[<span class="hljs-string">"presId"</span>];
    <span class="hljs-comment">// presId is mandatory when reconnecting to a presentation.</span>
    <span class="hljs-keyword">if</span> (!!presId) {
      request.reconnect(presId)
        <span class="hljs-comment">// The new connection to the presentation will be passed to</span>
        <span class="hljs-comment">// setConnection on success.</span>
        .then(setConnection);
        <span class="hljs-comment">// No connection found for presUrl and presId, or an error occurred.</span>
    }
  };
  <span class="hljs-comment">// On navigation of the controller, reconnect automatically.</span>
  <span class="hljs-built_in">document</span>.addEventListener(<span class="hljs-string">"DOMContentLoaded"</span>, reconnect);
  <span class="hljs-comment">// Or allow manual reconnection.</span>
  reconnectBtn.onclick = reconnect;
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<section id="presentation-initiation-by-the-controlling-ua-example">
<h3 id="Presentation_initiation_by_the_controlling_UA"><span>Presentation initiation by the controlling UA </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- controller.html --&gt;</span>
<span class="hljs-comment">&lt;!-- Setting presentation.defaultRequest allows the page to specify the
     PresentationRequest to use when the controlling UA initiates a
     presentation. --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  navigator.presentation.defaultRequest = <span class="hljs-keyword">new</span> PresentationRequest(presUrls);
  navigator.presentation.defaultRequest.onconnectionavailable = <span class="hljs-function"><span class="hljs-keyword">function</span>(<span class="hljs-params">evt</span>) </span>{
    setConnection(evt.connection);
  };
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<section id="monitor-connection-s-state-and-exchange-data-example">
<h3 id="Monitor_connections_state_and_exchange_data"><span>Monitor connection's state and exchange data </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- controller.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">id</span>=<span class="hljs-string">"disconnectBtn"</span> <span class="hljs-attr">style</span>=<span class="hljs-string">"display: none;"</span>&gt;</span>Disconnect<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">id</span>=<span class="hljs-string">"stopBtn"</span> <span class="hljs-attr">style</span>=<span class="hljs-string">"display: none;"</span>&gt;</span>Stop<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">button</span> <span class="hljs-attr">id</span>=<span class="hljs-string">"reconnectBtn"</span> <span class="hljs-attr">style</span>=<span class="hljs-string">"display: none;"</span>&gt;</span>Reconnect<span class="hljs-tag">&lt;/<span class="hljs-name">button</span>&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  <span class="hljs-keyword">let</span> connection;

  <span class="hljs-comment">// The Disconnect and Stop buttons are visible if there is a connected presentation</span>
  <span class="hljs-keyword">const</span> stopBtn = <span class="hljs-built_in">document</span>.querySelector(<span class="hljs-string">"#stopBtn"</span>);
  <span class="hljs-keyword">const</span> reconnectBtn = <span class="hljs-built_in">document</span>.querySelector(<span class="hljs-string">"#reconnectBtn"</span>);
  <span class="hljs-keyword">const</span> disconnectBtn = <span class="hljs-built_in">document</span>.querySelector(<span class="hljs-string">"#disconnectBtn"</span>);

  stopBtn.onclick = <span class="hljs-function"><span class="hljs-params">_</span> =&gt;</span> {
    connection &amp;&amp; connection.terminate();
  };

  disconnectBtn.onclick = <span class="hljs-function"><span class="hljs-params">_</span> =&gt;</span> {
    connection &amp;&amp; connection.close();
  };

  <span class="hljs-function"><span class="hljs-keyword">function</span> <span class="hljs-title">setConnection</span>(<span class="hljs-params">newConnection</span>) </span>{
    <span class="hljs-comment">// Disconnect from existing presentation, if not attempting to reconnect</span>
    <span class="hljs-keyword">if</span> (connection &amp;&amp; connection != newConnection &amp;&amp; connection.state != <span class="hljs-string">'closed'</span>) {
      connection.onclosed = <span class="hljs-literal">undefined</span>;
      connection.close();
    }

    <span class="hljs-comment">// Set the new connection and save the presentation ID</span>
    connection = newConnection;
    localStorage[<span class="hljs-string">"presId"</span>] = connection.id;

    <span class="hljs-function"><span class="hljs-keyword">function</span> <span class="hljs-title">showConnectedUI</span>() </span>{
      <span class="hljs-comment">// Allow the user to disconnect from or terminate the presentation</span>
      stopBtn.style.display = <span class="hljs-string">"inline"</span>;
      disconnectBtn.style.display = <span class="hljs-string">"inline"</span>;
      reconnectBtn.style.display = <span class="hljs-string">"none"</span>;
    }

    <span class="hljs-function"><span class="hljs-keyword">function</span> <span class="hljs-title">showDisconnectedUI</span>() </span>{
      disconnectBtn.style.display = <span class="hljs-string">"none"</span>;
      stopBtn.style.display = <span class="hljs-string">"none"</span>;
      reconnectBtn.style.display = localStorage[<span class="hljs-string">"presId"</span>] ? <span class="hljs-string">"inline"</span> : <span class="hljs-string">"none"</span>;
    }

    <span class="hljs-comment">// Monitor the connection state</span>
    connection.onconnect = <span class="hljs-function"><span class="hljs-params">_</span> =&gt;</span> {
      showConnectedUI();

      <span class="hljs-comment">// Register message handler</span>
      connection.onmessage = <span class="hljs-function"><span class="hljs-params">message</span> =&gt;</span> {
        <span class="hljs-built_in">console</span>.log(<span class="hljs-string">`Received message: <span class="hljs-subst">${message.data}</span>`</span>);
      };

      <span class="hljs-comment">// Send initial message to presentation page</span>
      connection.send(<span class="hljs-string">"Say hello"</span>);
    };

    connection.onclose = <span class="hljs-function"><span class="hljs-params">_</span> =&gt;</span> {
      connection = <span class="hljs-literal">null</span>;
      showDisconnectedUI();
    };

    connection.onterminate = <span class="hljs-function"><span class="hljs-params">_</span> =&gt;</span> {
      <span class="hljs-comment">// Remove presId from localStorage if exists</span>
      <span class="hljs-keyword">delete</span> localStorage[<span class="hljs-string">"presId"</span>];
      connection = <span class="hljs-literal">null</span>;
      showDisconnectedUI();
    };
  };
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<section id="monitor-available-connection-s-and-say-hello">
<h3 id="Monitor_available_connections_and_say_hello"><span>Monitor available connection(s) and say hello </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- presentation.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  <span class="hljs-keyword">var</span> addConnection = <span class="hljs-function"><span class="hljs-keyword">function</span>(<span class="hljs-params">connection</span>) </span>{
    <span class="hljs-keyword">this</span>.onmessage = <span class="hljs-function"><span class="hljs-keyword">function</span> (<span class="hljs-params">message</span>) </span>{
      <span class="hljs-keyword">if</span> (message.data == <span class="hljs-string">"say hello"</span>)
        <span class="hljs-keyword">this</span>.send(<span class="hljs-string">"hello"</span>);
    };
  };

  navigator.presentation.receiver.connectionList.then(<span class="hljs-function"><span class="hljs-keyword">function</span> (<span class="hljs-params">list</span>) </span>{
    list.connections.map(<span class="hljs-function"><span class="hljs-keyword">function</span> (<span class="hljs-params">connection</span>) </span>{
      addConnection(connection);
    });
    list.onconnectionavailable = <span class="hljs-function"><span class="hljs-keyword">function</span> (<span class="hljs-params">evt</span>) </span>{
      addConnection(evt.connection);
    };
  });
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<section id="passing-locale-information-with-a-message">
<h3 id="Passing_locale_information_with_a_message"><span>Passing locale information with a message </span></h3>

<div class="example">
<pre class="brush: js"><span class="hljs-comment">&lt;!-- controller.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  connection.send(<span class="hljs-string">"{string: '你好，世界!', lang: 'zh-CN'}"</span>);
  connection.send(<span class="hljs-string">"{string: 'こんにちは、世界!', lang: 'ja'}"</span>);
  connection.send(<span class="hljs-string">"{string: '안녕하세요, 세계!', lang: 'ko'}"</span>);
  connection.send(<span class="hljs-string">"{string: 'Hello, world!', lang: 'en-US'}"</span>);
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span>

<span class="hljs-comment">&lt;!-- presentation.html --&gt;</span>
<span class="hljs-tag">&lt;<span class="hljs-name">script</span>&gt;</span><span class="javascript">
  connection.onmessage = <span class="hljs-function"><span class="hljs-keyword">function</span> (<span class="hljs-params">message</span>) </span>{
    <span class="hljs-keyword">var</span> messageObj = <span class="hljs-built_in">JSON</span>.parse(message.data);
    <span class="hljs-keyword">var</span> spanElt = <span class="hljs-built_in">document</span>.createElement(<span class="hljs-string">"SPAN"</span>);
    spanElt.lang = messageObj.lang;
    spanElt.textContent = messageObj.string;
    <span class="hljs-built_in">document</span>.appendChild(spanElt);
  };
</span><span class="hljs-tag">&lt;/<span class="hljs-name">script</span>&gt;</span></pre>
</div>
</section>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Presentation')}}</td>
   <td>{{Spec2('Presentation')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Presentation"><code>Presentation</code></h3>

<div>

<p>{{Compat("api.Presentation")}}</p>
</div>

<h2 id="See_also">See also</h2>

<p><a href="https://mediascape.github.io/presentation-api-polyfill/">Presentation API polyfill</a> contains a JavaScript polyfill of the <a href="https://w3c.github.io/presentation-api/">Presentation API</a> specification under standardisation within the <a href="https://www.w3.org/2014/secondscreen/">Second Screen Working Group</a> at W3C. The polyfill is mostly intended for exploring how the Presentation API may be implemented on top of different presentation mechanisms.</p>
